## ilmbase 2.3.0

=== CMakeLists.txt ===

IF (WIN32)
    CMAKE_MINIMUM_REQUIRED(VERSION 3.11)
ELSE()
    CMAKE_MINIMUM_REQUIRED(VERSION 3.2)
ENDIF()

PROJECT ( ilmbase )

set(ILMBASE_BASEVERSION   ${OPENEXR_BASEVERSION})
set(ILMBASE_VERSION_MAJOR ${OPENEXR_VERSION_MAJOR})
set(ILMBASE_VERSION_MINOR ${OPENEXR_VERSION_MINOR})
set(ILMBASE_VERSION_PATCH ${OPENEXR_VERSION_PATCH})
set(ILMBASE_VERSION       ${OPENEXR_VERSION})
set(ILMBASE_VERSION_API   ${OPENEXR_VERSION_API})

INCLUDE_DIRECTORIES ( Iex IexMath Imath Half
    IlmThread IexTest ImathTest HalfTest
    ${CMAKE_CURRENT_BINARY_DIR}/config )

IF(WIN32)
  SET(CMAKE_DEBUG_POSTFIX "_d")
ENDIF()

# also add the current directory to pick up the autogenerated headers
SET(CMAKE_INCLUDE_CURRENT_DIR ON)

MACRO(GET_TARGET_PROPERTY_WITH_DEFAULT _variable _target _property _default_value)
   GET_TARGET_PROPERTY (${_variable} ${_target} ${_property})
   IF (${_variable} MATCHES NOTFOUND)
     SET (${_variable} ${_default_value})
   ENDIF (${_variable} MATCHES NOTFOUND)
 ENDMACRO (GET_TARGET_PROPERTY_WITH_DEFAULT)

 MACRO(CREATE_LIBTOOL_FILE _target _install_DIR)
   SET(_target_location $<TARGET_FILE:${_target}>)
   GET_TARGET_PROPERTY_WITH_DEFAULT(_target_static_lib ${_target} STATIC_LIB "")
   GET_TARGET_PROPERTY_WITH_DEFAULT(_target_dependency_libs ${_target} LT_DEPENDENCY_LIBS "")
   GET_TARGET_PROPERTY_WITH_DEFAULT(_target_current ${_target} LT_VERSION_CURRENT 0)
   GET_TARGET_PROPERTY_WITH_DEFAULT(_target_age ${_target} LT_VERSION_AGE 0)
   GET_TARGET_PROPERTY_WITH_DEFAULT(_target_revision ${_target} LT_VERSION_REVISION 0)
   GET_TARGET_PROPERTY_WITH_DEFAULT(_target_installed ${_target} LT_INSTALLED yes)
   GET_TARGET_PROPERTY_WITH_DEFAULT(_target_shouldnotlink ${_target} LT_SHOULDNOTLINK yes)
   GET_TARGET_PROPERTY_WITH_DEFAULT(_target_dlopen ${_target} LT_DLOPEN "")
   GET_TARGET_PROPERTY_WITH_DEFAULT(_target_dlpreopen ${_target} LT_DLPREOPEN "")
   SET(_laname ${_target}${OPENEXR_LIBSUFFIX})
   SET(_soname ${_laname})
   SET(_laname ${PROJECT_BINARY_DIR}/${_laname}.la)
   FILE(WRITE ${_laname} "# ${_laname} - a libtool library file\n")
   FILE(APPEND ${_laname} "# Generated by CMake ${CMAKE_VERSION} (like GNU libtool)\n")
   FILE(APPEND ${_laname} "\n# Please DO NOT delete this file!\n# It is necessary for linking the library with libtool.\n\n" )
   FILE(APPEND ${_laname} "# The name that we can dlopen(3).\n")
   FILE(APPEND ${_laname} "dlname='${_soname}'\n\n")
   FILE(APPEND ${_laname} "# Names of this library.\n")
   FILE(APPEND ${_laname} "library_names='${_soname}.${_target_current}.${_target_age}.${_target_revision} ${_soname}.${_target_current} ${_soname}'\n\n")
   FILE(APPEND ${_laname} "# The name of the static archive.\n")
   FILE(APPEND ${_laname} "old_library='${_target_static_lib}'\n\n")
   FILE(APPEND ${_laname} "# Libraries that this one depends upon.\n")
   FILE(APPEND ${_laname} "dependency_libs='${_target_dependency_libs}'\n\n")
   FILE(APPEND ${_laname} "# Names of additional weak libraries provided by this library\n")
   FILE(APPEND ${_laname} "weak_library_names=\n\n")
   FILE(APPEND ${_laname} "# Version information for ${_laname}.\n")
   FILE(APPEND ${_laname} "current=${_target_current}\n")
   FILE(APPEND ${_laname} "age=${_target_age}\n")
   FILE(APPEND ${_laname} "revision=${_target_revision}\n\n")
   FILE(APPEND ${_laname} "# Is this an already installed library?\n")
   FILE(APPEND ${_laname} "installed=${_target_installed}\n\n")
   FILE(APPEND ${_laname} "# Should we warn about portability when linking against -modules?\n")
   FILE(APPEND ${_laname} "shouldnotlink=${_target_shouldnotlink}\n\n")
   FILE(APPEND ${_laname} "# Files to dlopen/dlpreopen\n")
   FILE(APPEND ${_laname} "dlopen='${_target_dlopen}'\n")
   FILE(APPEND ${_laname} "dlpreopen='${_target_dlpreopen}'\n\n")
   FILE(APPEND ${_laname} "# Directory that this library needs to be installed in:\n")
   FILE(APPEND ${_laname} "libdir='${CMAKE_INSTALL_PREFIX}${_install_DIR}'\n")
   INSTALL( FILES ${_laname} DESTINATION ${CMAKE_INSTALL_PREFIX}${_install_DIR})
 ENDMACRO(CREATE_LIBTOOL_FILE)

ADD_SUBDIRECTORY ( Half )
ADD_SUBDIRECTORY ( Iex )
ADD_SUBDIRECTORY ( IexMath )
ADD_SUBDIRECTORY ( Imath )
ADD_SUBDIRECTORY ( IlmThread )


##########################
# IlmBaseConfig.h generation
##########################

# By using a temp file then using configure_file below with copy, we
# avoid constantly updating it (unless a value has changed)
SET(ILMBASE_TMP_CONFIG ${CMAKE_CURRENT_BINARY_DIR}/config/IlmBaseConfig.h.in)
IF (WIN32)
  FILE ( WRITE  ${ILMBASE_TMP_CONFIG} "#ifdef HAVE_PTHREAD\n" )
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "# undef HAVE_PTHREAD\n" )
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#endif\n" )
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#ifdef HAVE_POSIX_SEMAPHORES\n" )
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "# undef HAVE_POSIX_SEMAPHORES\n" )
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#endif\n" )
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define PLATFORM_WINDOWS 1\n" )
ELSE ()
  IF (APPLE)
    FILE ( WRITE  ${ILMBASE_TMP_CONFIG} "#define HAVE_PTHREAD 1\n" )
  ELSE ()
    FILE ( WRITE  ${ILMBASE_TMP_CONFIG} "#define HAVE_PTHREAD 1\n" )
    FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMBASE_HAVE_LARGE_STACK  1\n" )
    FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define HAVE_POSIX_SEMAPHORES 1\n" )
    FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMBASE_HAVE_CONTROL_REGISTER_SUPPORT 1\n")
  ENDIF ()
ENDIF ()

IF (OPENEXR_FORCE_CXX03)
  FILE ( APPEND  ${ILMBASE_TMP_CONFIG} "#define ILMBASE_FORCE_CXX03 1\n" )
ELSEIF (NOT WIN32)
  # really only care about c++11 right now for the threading bits, but this can be changed to 14
  # when needed...
  # Note that the __cplusplus check is not valid under MSVC
  FILE ( APPEND  ${ILMBASE_TMP_CONFIG} "#if __cplusplus < 201103L\n# error \"Modern C++ 11/14 not enabled but force cxx03 not set\"\n#endif\n" )
ENDIF ()

IF (OPENEXR_NAMESPACE_VERSIONING)
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMBASE_INTERNAL_NAMESPACE_CUSTOM 1\n")
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define IMATH_INTERNAL_NAMESPACE Imath_${ILMBASE_VERSION_API}\n")
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define IEX_INTERNAL_NAMESPACE Iex_${ILMBASE_VERSION_API}\n")
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMTHREAD_INTERNAL_NAMESPACE IlmThread_${ILMBASE_VERSION_API}\n")
ELSE ()
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMBASE_INTERNAL_NAMESPACE_CUSTOM 0\n")
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define IMATH_INTERNAL_NAMESPACE Imath\n")
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define IEX_INTERNAL_NAMESPACE Iex\n")
  FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMTHREAD_INTERNAL_NAMESPACE IlmThread\n")
ENDIF ()

FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define IMATH_NAMESPACE Imath\n")
FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define IEX_NAMESPACE Iex\n")
FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMTHREAD_NAMESPACE IlmThread\n")
FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMBASE_VERSION_STRING \"${ILMBASE_VERSION}\"\n" )
FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMBASE_PACKAGE_STRING \"IlmBase ${ILMBASE_VERSION}\"\n" )
FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMBASE_VERSION_MAJOR ${ILMBASE_VERSION_MAJOR}\n" )
FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMBASE_VERSION_MINOR ${ILMBASE_VERSION_MINOR}\n" )
FILE ( APPEND ${ILMBASE_TMP_CONFIG} "#define ILMBASE_VERSION_PATCH ${ILMBASE_VERSION_PATCH}\n" )

FILE ( APPEND ${ILMBASE_TMP_CONFIG} "
// Version as a single hex number, e.g. 0x01000300 == 1.0.3
#define ILMBASE_VERSION_HEX ((ILMBASE_VERSION_MAJOR << 24) | \\
                             (ILMBASE_VERSION_MINOR << 16) | \\
                             (ILMBASE_VERSION_PATCH <<  8))
")

CONFIGURE_FILE ( ${ILMBASE_TMP_CONFIG} ${CMAKE_CURRENT_BINARY_DIR}/config/IlmBaseConfig.h COPYONLY )
FILE ( REMOVE ${ILMBASE_TMP_CONFIG} )
UNSET ( ILMBASE_TMP_CONFIG )

IF ( NOT WIN32 AND OPENEXR_BUILD_SHARED )
  CREATE_LIBTOOL_FILE ( Half /lib )
  CREATE_LIBTOOL_FILE ( Iex /lib )
  CREATE_LIBTOOL_FILE ( IexMath /lib )
  CREATE_LIBTOOL_FILE ( Imath /lib )
  CREATE_LIBTOOL_FILE ( IlmThread /lib )
ENDIF ()


# Tests
IF ( ENABLE_TESTS )
  ADD_SUBDIRECTORY ( HalfTest )
  ADD_SUBDIRECTORY ( IexTest )
  ADD_SUBDIRECTORY ( ImathTest )
ENDIF ()

# Installation

INSTALL ( FILES
  ${CMAKE_CURRENT_BINARY_DIR}/config/IlmBaseConfig.h
  DESTINATION
  include/OpenEXR
)

IF ( NOT WIN32 )
  FILE ( WRITE ${CMAKE_BINARY_DIR}/IlmBase.pc "prefix=${CMAKE_INSTALL_PREFIX}\n" )
  FILE ( APPEND ${CMAKE_BINARY_DIR}/IlmBase.pc "exec_prefix=\${prefix}
libdir=\${exec_prefix}/lib
includedir=\${prefix}/include
OpenEXR_includedir=\${prefix}/include/OpenEXR

Name: IlmBase
Description: Base math and exception libraries
Version: ${ILMBASE_VERSION}
Libs: -L\${libdir} -lImath${ILMBASE_LIBSUFFIX} -lIexMath${ILMBASE_LIBSUFFIX} -lHalf${ILMBASE_LIBSUFFIX} -lIex${ILMBASE_LIBSUFFIX} -lIlmThread${ILMBASE_LIBSUFFIX} -pthread
Cflags: -pthread -I\${OpenEXR_includedir}
")

  INSTALL ( FILES
    ${CMAKE_BINARY_DIR}/IlmBase.pc
    DESTINATION
    lib/pkgconfig
  )
ENDIF()

=== Half/CMakeLists.txt ===
# yue.nicholas@gmail.com

ADD_EXECUTABLE ( eLut eLut.cpp )
ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/eLut.h
  COMMAND $<TARGET_FILE:eLut> ARGS > ${CMAKE_CURRENT_BINARY_DIR}/eLut.h
  DEPENDS eLut)
SET_SOURCE_FILES_PROPERTIES(
  ${CMAKE_CURRENT_BINARY_DIR}/eLut.h
  PROPERTIES HEADER_FILE_ONLY TRUE)

ADD_EXECUTABLE ( toFloat toFloat.cpp )
ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/toFloat.h
  COMMAND $<TARGET_FILE:toFloat> ARGS > ${CMAKE_CURRENT_BINARY_DIR}/toFloat.h
  DEPENDS toFloat)

SET_SOURCE_FILES_PROPERTIES(
  ${CMAKE_CURRENT_BINARY_DIR}/toFloat.h
  PROPERTIES HEADER_FILE_ONLY TRUE)

SET_SOURCE_FILES_PROPERTIES(
  half.cpp
  PROPERTIES
  OBJECT_DEPENDS
  "${CMAKE_CURRENT_BINARY_DIR}/eLut.h;${CMAKE_CURRENT_BINARY_DIR}/toFloat.h"
  )

SET (ILMBASE_LIB_TARGETS "")

IF (OPENEXR_BUILD_SHARED)
  LIST ( APPEND ILMBASE_LIB_TARGETS Half )

  ADD_LIBRARY ( Half SHARED
    half.cpp
    )

  TARGET_COMPILE_DEFINITIONS ( Half PRIVATE HALF_EXPORTS )
  IF (WIN32)
    TARGET_COMPILE_DEFINITIONS ( Half PUBLIC OPENEXR_DLL )
  ENDIF ()

  SET_TARGET_PROPERTIES ( Half
    PROPERTIES
    VERSION ${OPENEXR_VERSION}
    SOVERSION ${OPENEXR_SOVERSION}
    OUTPUT_NAME "Half${ILMBASE_LIBSUFFIX}"
    )

  ADD_DEPENDENCIES ( Half toFloat eLut )
ENDIF ()

IF (BUILD_ILMBASE_STATIC)
  LIST ( APPEND ILMBASE_LIB_TARGETS Half_static )

  ADD_LIBRARY ( Half_static STATIC
    half.cpp
    )

  SET_TARGET_PROPERTIES ( Half_static
    PROPERTIES
    VERSION ${ILMBASE_VERSION_MAJOR}.${ILMBASE_VERSION_MINOR}.${ILMBASE_VERSION_PATCH}
    OUTPUT_NAME "Half${ILMBASE_LIBSUFFIX}_s"
    )

  ADD_DEPENDENCIES ( Half_static toFloat eLut )
ENDIF ()

IF (OPENEXR_BUILD_SHARED OR BUILD_ILMBASE_STATIC)
  INSTALL ( TARGETS
    ${ILMBASE_LIB_TARGETS}
      ARCHIVE DESTINATION lib
      LIBRARY DESTINATION lib
      RUNTIME DESTINATION ${RUNTIME_DIR}
  )
ENDIF ()

INSTALL (
  FILES
    half.h
    halfFunction.h
    halfExport.h
    halfLimits.h

  DESTINATION
    include/OpenEXR
)

if (OPENEXR_BUILD_SHARED)
    add_library(IlmBase::Half ALIAS Half)
endif()
if (BUILD_ILMBASE_STATIC)
    add_library(IlmBase::Half_static ALIAS Half_static)
endif()

=== HalfTest/CMakeLists.txt ===
# yue.nicholas@gmail.com

ADD_EXECUTABLE ( HalfTest
  main.cpp
  testArithmetic.cpp
  testBitPatterns.cpp
  testClassification.cpp
  testError.cpp
  testFunction.cpp
  testLimits.cpp
  testSize.cpp
  )

TARGET_LINK_LIBRARIES ( HalfTest IlmBase::Half${OPENEXR_TARGET_SUFFIX} )

ADD_TEST ( TestHalf HalfTest )

=== Iex/CMakeLists.txt ===
# yue.nicholas@gmail.com

SET (ILMBASE_LIB_TARGETS "")

IF(OPENEXR_BUILD_SHARED)
  LIST ( APPEND ILMBASE_LIB_TARGETS Iex )

  ADD_LIBRARY ( Iex SHARED
    IexBaseExc.cpp
    IexThrowErrnoExc.cpp
    )

  TARGET_COMPILE_DEFINITIONS ( Iex PRIVATE IEX_EXPORTS )
  IF (WIN32)
    TARGET_COMPILE_DEFINITIONS ( Iex PUBLIC OPENEXR_DLL )
  ENDIF ()

  SET_TARGET_PROPERTIES ( Iex
    PROPERTIES
    VERSION ${OPENEXR_VERSION}
    SOVERSION ${OPENEXR_SOVERSION}
    OUTPUT_NAME "Iex${ILMBASE_LIBSUFFIX}"
    )
ENDIF()

IF (BUILD_ILMBASE_STATIC)
  LIST ( APPEND ILMBASE_LIB_TARGETS Iex_static )

  ADD_LIBRARY ( Iex_static STATIC
    IexBaseExc.cpp
    IexThrowErrnoExc.cpp
    )

  SET_TARGET_PROPERTIES ( Iex_static
    PROPERTIES
    VERSION ${ILMBASE_VERSION_MAJOR}.${ILMBASE_VERSION_MINOR}.${ILMBASE_VERSION_PATCH}
    OUTPUT_NAME "Iex${ILMBASE_LIBSUFFIX}_s"
    )
ENDIF()

IF (OPENEXR_BUILD_SHARED OR BUILD_ILMBASE_STATIC)
  INSTALL ( TARGETS ${ILMBASE_LIB_TARGETS}
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION ${RUNTIME_DIR}
  )
ENDIF ()

INSTALL (
  FILES
    IexBaseExc.h
    IexMathExc.h
    IexThrowErrnoExc.h
    IexErrnoExc.h
    IexMacros.h
    Iex.h
    IexNamespace.h
    IexExport.h
    IexForward.h

  DESTINATION
    include/OpenEXR
)

if (OPENEXR_BUILD_SHARED)
    add_library(IlmBase::Iex ALIAS Iex)
endif()
if (BUILD_ILMBASE_STATIC)
    add_library(IlmBase::Iex_static ALIAS Iex_static)
endif()

=== IexMath/CMakeLists.txt ===
# pstanczyk@ilm.com

SET (ILMBASE_LIB_TARGETS "")

IF ( OPENEXR_BUILD_SHARED )
  LIST ( APPEND ILMBASE_LIB_TARGETS IexMath )

  ADD_LIBRARY ( IexMath SHARED
    IexMathFloatExc.cpp
    IexMathFpu.cpp
    )

  TARGET_COMPILE_DEFINITIONS ( IexMath PRIVATE IEXMATH_EXPORTS )
  IF (WIN32)
    TARGET_COMPILE_DEFINITIONS ( IexMath PUBLIC OPENEXR_DLL )
  ENDIF ()

  TARGET_LINK_LIBRARIES( IexMath
    PUBLIC IlmBase::Iex )
  SET_TARGET_PROPERTIES ( IexMath
    PROPERTIES
    VERSION ${OPENEXR_VERSION}
    SOVERSION ${OPENEXR_SOVERSION}
    OUTPUT_NAME "IexMath${ILMBASE_LIBSUFFIX}"
    )
ENDIF ()

IF (BUILD_ILMBASE_STATIC)
  LIST ( APPEND ILMBASE_LIB_TARGETS IexMath_static )

  ADD_LIBRARY ( IexMath_static STATIC
    IexMathFloatExc.cpp
    IexMathFpu.cpp
    )

  SET_TARGET_PROPERTIES ( IexMath_static
    PROPERTIES
    VERSION ${ILMBASE_VERSION_MAJOR}.${ILMBASE_VERSION_MINOR}.${ILMBASE_VERSION_PATCH}
    OUTPUT_NAME "IexMath${ILMBASE_LIBSUFFIX}_s"
    )
ENDIF( )

IF (OPENEXR_BUILD_SHARED OR BUILD_ILMBASE_STATIC)
  INSTALL ( TARGETS ${ILMBASE_LIB_TARGETS}
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION ${RUNTIME_DIR}
  )
ENDIF ()

INSTALL (
  FILES
    IexMathFloatExc.h
    IexMathFpu.h
    IexMathIeeeExc.h

  DESTINATION
    include/OpenEXR
)

if (OPENEXR_BUILD_SHARED)
    add_library(IlmBase::IexMath ALIAS IexMath)
endif()
if (BUILD_ILMBASE_STATIC)
    add_library(IlmBase::IexMath_static ALIAS IexMath_static)
endif()

=== IexTest/CMakeLists.txt ===
# yue.nicholas@gmail.com

ADD_EXECUTABLE ( IexTest
  main.cpp
  testBaseExc.cpp
  )

TARGET_LINK_LIBRARIES ( IexTest IlmBase::Iex${OPENEXR_TARGET_SUFFIX} )

ADD_TEST ( TestIex IexTest )

=== IlmThread/CMakeLists.txt ===
# yue.nicholas@gmail.com

SET( ILMTHREAD_LIBRARY_SOURCES
  IlmThread.cpp
  IlmThreadMutex.cpp
  IlmThreadMutexPosix.cpp
  IlmThreadPool.cpp
  IlmThreadPosix.cpp
  IlmThreadSemaphore.cpp
  IlmThreadSemaphorePosixCompat.cpp
  IlmThreadSemaphorePosix.cpp
)
IF (WIN32)
  SET( ILMTHREAD_LIBRARY_SOURCES ${ILMTHREAD_LIBRARY_SOURCES}
    IlmThreadMutexWin32.cpp
    IlmThreadSemaphoreWin32.cpp
    IlmThreadWin32.cpp
  )
ENDIF()

SET (ILMBASE_LIB_TARGETS "")

IF ( OPENEXR_BUILD_SHARED )
  LIST ( APPEND ILMBASE_LIB_TARGETS IlmThread )

  ADD_LIBRARY ( IlmThread SHARED ${ILMTHREAD_LIBRARY_SOURCES} )

  TARGET_COMPILE_DEFINITIONS ( IlmThread PRIVATE ILMTHREAD_EXPORTS )
  IF (WIN32)
    TARGET_COMPILE_DEFINITIONS ( IlmThread PUBLIC OPENEXR_DLL )
  ENDIF ()

  TARGET_LINK_LIBRARIES( IlmThread
    PUBLIC IlmBase::Iex )

  SET_TARGET_PROPERTIES ( IlmThread
    PROPERTIES
    VERSION ${OPENEXR_VERSION}
    SOVERSION ${OPENEXR_SOVERSION}
    OUTPUT_NAME "IlmThread${ILMBASE_LIBSUFFIX}"
    )
ENDIF ()

IF (BUILD_ILMBASE_STATIC)
  LIST ( APPEND ILMBASE_LIB_TARGETS IlmThread_static )

  ADD_LIBRARY ( IlmThread_static STATIC ${ILMTHREAD_LIBRARY_SOURCES} )

  SET_TARGET_PROPERTIES ( IlmThread_static
    PROPERTIES
    VERSION ${ILMBASE_VERSION_MAJOR}.${ILMBASE_VERSION_MINOR}.${ILMBASE_VERSION_PATCH}
    OUTPUT_NAME "IlmThread${ILMBASE_LIBSUFFIX}_s"
    )
ENDIF ()

IF (OPENEXR_BUILD_SHARED OR BUILD_ILMBASE_STATIC)
  INSTALL ( TARGETS ${ILMBASE_LIB_TARGETS}
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION ${RUNTIME_DIR}
  )
ENDIF ()

INSTALL (
  FILES
    IlmThreadPool.h
    IlmThread.h
    IlmThreadSemaphore.h
    IlmThreadMutex.h
    IlmThreadNamespace.h
    IlmThreadExport.h
    IlmThreadForward.h

  DESTINATION
    include/OpenEXR
)

if (OPENEXR_BUILD_SHARED)
    add_library(IlmBase::IlmThread ALIAS IlmThread)
endif()
if (BUILD_ILMBASE_STATIC)
    add_library(IlmBase::IlmThread_static ALIAS IlmThread_static)
endif()

=== Imath/CMakeLists.txt ===
# yue.nicholas@gmail.com

SET (ILMBASE_LIB_TARGETS "")

SET ( IMATH_SOURCES
  ImathRandom.cpp
  ImathColorAlgo.cpp
  ImathFun.cpp
  ImathVec.cpp
  ImathMatrixAlgo.cpp
)

IF ( OPENEXR_BUILD_SHARED )
  LIST ( APPEND ILMBASE_LIB_TARGETS Imath )

  ADD_LIBRARY ( Imath SHARED ${IMATH_SOURCES} )

  TARGET_COMPILE_DEFINITIONS ( Imath PRIVATE IMATH_EXPORTS )
  IF (WIN32)
    TARGET_COMPILE_DEFINITIONS ( Imath PUBLIC OPENEXR_DLL )
  ENDIF ()

  TARGET_LINK_LIBRARIES(Imath PUBLIC IlmBase::Iex)
  SET_TARGET_PROPERTIES ( Imath
    PROPERTIES
    VERSION ${OPENEXR_VERSION}
    SOVERSION ${OPENEXR_SOVERSION}
    OUTPUT_NAME "Imath${ILMBASE_LIBSUFFIX}"
    )
ENDIF ()

IF (BUILD_ILMBASE_STATIC)
  LIST ( APPEND ILMBASE_LIB_TARGETS Imath_static )

  ADD_LIBRARY ( Imath_static STATIC ${IMATH_SOURCES} )

  SET_TARGET_PROPERTIES ( Imath_static
    PROPERTIES
    VERSION ${ILMBASE_VERSION_MAJOR}.${ILMBASE_VERSION_MINOR}.${ILMBASE_VERSION_PATCH}
    OUTPUT_NAME "Imath${ILMBASE_LIBSUFFIX}_s"
    )
ENDIF ()

IF (OPENEXR_BUILD_SHARED OR BUILD_ILMBASE_STATIC)
  INSTALL ( TARGETS ${ILMBASE_LIB_TARGETS}
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION ${RUNTIME_DIR}
  )
ENDIF ()

INSTALL (
  FILES
    ImathBoxAlgo.h
    ImathBox.h
    ImathColorAlgo.h
    ImathColor.h
    ImathEuler.h
    ImathExc.h
    ImathExport.h
    ImathForward.h
    ImathFrame.h
    ImathFrustum.h
    ImathFrustumTest.h
    ImathFun.h
    ImathGL.h
    ImathGLU.h
    ImathHalfLimits.h
    ImathInt64.h
    ImathInterval.h
    ImathLimits.h
    ImathLineAlgo.h
    ImathLine.h
    ImathMath.h
    ImathMatrixAlgo.h
    ImathMatrix.h
    ImathNamespace.h
    ImathPlane.h
    ImathPlatform.h
    ImathQuat.h
    ImathRandom.h
    ImathRoots.h
    ImathShear.h
    ImathSphere.h
    ImathVecAlgo.h
    ImathVec.h

  DESTINATION
    include/OpenEXR
)

if (OPENEXR_BUILD_SHARED)
    add_library(IlmBase::Imath ALIAS Imath)
endif()
if (BUILD_ILMBASE_STATIC)
    add_library(IlmBase::Imath_static ALIAS Imath_static)
endif()

=== ImathTest/CMakeLists.txt ===
# yue.nicholas@gmail.com

ADD_EXECUTABLE ( ImathTest 
  main.cpp
  testBox.cpp
  testBoxAlgo.cpp
  testColor.cpp
  testExtractEuler.cpp
  testExtractSHRT.cpp
  testFrustum.cpp
  testFrustumTest.cpp
  testFun.cpp
  testInvert.cpp
  testJacobiEigenSolver.cpp
  testLineAlgo.cpp
  testMatrix.cpp
  testMiscMatrixAlgo.cpp
  testProcrustes.cpp
  testQuat.cpp
  testQuatSetRotation.cpp
  testQuatSlerp.cpp
  testRandom.cpp
  testRoots.cpp
  testShear.cpp
  testTinySVD.cpp
  testVec.cpp
  )

ADD_TEST ( TestImath ImathTest )

TARGET_LINK_LIBRARIES ( ImathTest
  IlmBase::Imath${OPENEXR_TARGET_SUFFIX}
  IlmBase::Iex${OPENEXR_TARGET_SUFFIX}
  )

=== debian/changelog ===
ilmbase (2.3.0-6build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:44:15 +0100

ilmbase (2.3.0-6) unstable; urgency=medium

  * Upload to unstable
  * debian/: debhelper bump 11 -> 12
  * debian/control: S-V bump 4.3.0 -> 4.4.0 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 02 Sep 2019 14:32:22 +0200

ilmbase (2.3.0-5) experimental; urgency=medium

  * debian/overrides: Update libilmbase24
  * debian/control: Provide a clean upgrade path. Closes: #917457

 -- Mathieu Malaterre <malat@debian.org>  Mon, 07 Jan 2019 21:41:21 +0100

ilmbase (2.3.0-4) experimental; urgency=medium

  * debian/control: SONAME bump 23 -> 24 to reflect libtool numbering
  * debian/: filenames adapted to SONAME bump
  * debian/: debhelper bump 9 -> 12
  * debian/rules: drop autoreconf addon removed
  * debian/control: S-V bump 4.2.1 -> 4.3.0 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 02 Jan 2019 10:31:10 +0100

ilmbase (2.3.0-3) experimental; urgency=medium

  * Revert "debian/: move libilmbase-dev to M-A"
  * debian/: Remove arch specific from one header file

 -- Mathieu Malaterre <malat@debian.org>  Fri, 09 Nov 2018 10:07:49 +0100

ilmbase (2.3.0-2) experimental; urgency=medium

  * debian/patches/: patchset updated
    - fix_FTCBFS.patch added (Closes: #841439)
  * debian/: changes made to fix FTCBFS
    - control: autoconf-archive and dh-autoreconf added to b-deps
    - rules: override_dh_autoreconf entry and dh addon added

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 27 Oct 2018 22:45:50 +0200

ilmbase (2.3.0-1) experimental; urgency=medium

  * New upstream release
    - debian/: watch file and signing key updated
    - debian/patches/: patchset updated
      - bug843594.patch dropped (applied upstream)
    - debian/rules: rename README -> README.md
  * debian/: debhelper bump 9 -> 11
  * debian/: move libilmbase-dev to M-A (Closes: #841444)
  * debian/control:
    - Vcs-* fields updated for salsa
    - S-V bump 4.1.3 -> 4.2.1 (no changes needed)
  * debian/copyright: http:// -> https:// for copyright-format
  * debian/overrides/libilmbase23: override updated
  * debian/watch: add PGP verification for upstream tarballs

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 22 Oct 2018 23:33:22 +0200

=== debian/control ===
Source: ilmbase
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders:
 Mathieu Malaterre <malat@debian.org>,
 Matteo F. Vescovi <mfv@debian.org>
Build-Depends:
 autoconf-archive,
 debhelper-compat (= 12),
 dpkg-dev (>= 1.16.1)
Standards-Version: 4.4.0
Homepage: http://www.openexr.com
Vcs-Git: https://salsa.debian.org/debian-phototools-team/ilmbase.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/ilmbase

Package: libilmbase24
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends:
 ${misc:Pre-Depends}
Replaces: libilmbase23 (>= 2.3)
Breaks: libilmbase23 (>= 2.3)
Description: several utility libraries from ILM used by OpenEXR
 IlmBase are a set of utility libraries released by ILM, and used in
 their OpenEXR implementation. Included in this package you can find:
 .
  * libHalf: a class (Half) for manipulating "half" values (16-bit
    floating point format) as if they were a built-in C++ data type.
 .
  * libIlmThread: a thread abstraction library on top of pthreads.
 .
  * libImath: a math library with support for matrices, 2d- and
    3d-transformations, solvers for linear/quadratic/cubic equations,
    and more.
 .
  * libIex: an exception handling library.

Package: libilmbase-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libilmbase24 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends:
 ${misc:Pre-Depends}
Replaces: libopenexr-dev (<< 1.6)
Breaks: libopenexr-dev (<< 1.6)
Description: development files for IlmBase
 This package provides the development files for IlmBase, a set of
 utility libraries released by ILM and used by OpenEXR. Install this
 package if you want to compile a program that makes use of these
 libraries.

=== debian/rules ===
#! /usr/bin/make -f
#
# © 2009 Cyril Brulebois <kibi@debian.org>


##### VARIABLES
#

DEB_BUILD_ARCH      ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
#NO_MAKE_CHECK_ARCHS := arm
NO_FAIL_ON_TESTSUITE_ERROR := i386

ifeq (,$(filter $(DEB_BUILD_ARCH),alpha))
	export DEB_CFLAGS_MAINT_APPEND=-Wall
	export DEB_CXXFLAGS_MAINT_APPEND=-Wall
else
	export DEB_CFLAGS_MAINT_APPEND=-Wall -mieee
	export DEB_CXXFLAGS_MAINT_APPEND=-Wall -mieee
endif

##### OVERRIDES
#

override_dh_autoreconf:
	dh_autoreconf -- bash ./bootstrap

# Need to set an environment variable to make sure proper linking
# against libphtread happens:
override_dh_auto_configure:
	PTHREAD_LIBS=-lpthread \
		$(shell dpkg-buildflags --export=configure) \
		dh_auto_configure -v

# Need to disable the test suite on some architectures:
override_dh_auto_test:
ifeq (,$(filter $(DEB_BUILD_ARCH),$(NO_MAKE_CHECK_ARCHS)))
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (,$(filter $(DEB_BUILD_ARCH),$(NO_FAIL_ON_TESTSUITE_ERROR)))
	dh_auto_test -v
else
	dh_auto_test -v || echo TESTSUITE FAILED, continuing anyway.
endif
endif
endif

# Need to install those in both packages:
override_dh_installdocs:
	dh_installdocs AUTHORS NEWS README.md

override_dh_auto_install:
	dh_auto_install
	# see #841444
	sed -i /ILMBASE_HAVE_CONTROL_REGISTER_SUPPORT/d debian/tmp/usr/include/OpenEXR/IlmBaseConfig.h

# Need to pass -V to dh_makeshlibs:
override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_clean:
	dh_clean */Makefile
	dh_clean IlmBase.pc
	dh_clean Makefile
	dh_clean config.log
	dh_clean config.status
	dh_clean config/stamp-h1
	dh_clean libtool

# Everything else:
%:
	dh $@

## ilmbase 2.5.3

=== debian/changelog ===
ilmbase (2.5.3-2) unstable; urgency=medium

  * Upload to unstable

 -- Matteo F. Vescovi <mfv@debian.org>  Fri, 21 Aug 2020 22:17:44 +0200

ilmbase (2.5.3-1) experimental; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Fri, 14 Aug 2020 20:33:12 +0200

ilmbase (2.5.2-1) experimental; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 06 Aug 2020 17:28:50 +0200

ilmbase (2.5.1-1) experimental; urgency=medium

  * New upstream release
    - debian/: SONAME bump 24 -> 25
    - debian/patches/: patchset updated against v2.5.1
  * debian/watch: upstream URL updated
  * debian/control:
    - debhelper bump 12 -> 13
    - S-V bump 4.4.0 -> 4.5.0 (no changes needed)
    - RRR set
    - build-depends updated
  * debian/copyright: file path updated
  * debian/libilmbase-dev.install: cmake helpers added

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 21 May 2020 20:56:51 +0200

=== debian/control ===
--- 
+++ 
@@ -6,15 +6,16 @@
  Mathieu Malaterre <malat@debian.org>,
  Matteo F. Vescovi <mfv@debian.org>
 Build-Depends:
- autoconf-archive,
- debhelper-compat (= 12),
+ cmake,
+ debhelper-compat (= 13),
  dpkg-dev (>= 1.16.1)
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: http://www.openexr.com
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/ilmbase.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/ilmbase
 
-Package: libilmbase24
+Package: libilmbase25
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -44,7 +45,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends:
- libilmbase24 (= ${binary:Version}),
+ libilmbase25 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends}
 Pre-Depends:

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/archive\/(\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/, \
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ilmbase_$1\.tar\.gz/" \
https://github.com/AcademySoftwareFoundation/openexr/tags .*/v?(\d\S+)\.tar\.gz
